#include <fxlib.h>
#include <stdio.h>
#include <timer.h>
#include "Gray.h"
#include "GetKeys.h"
#include "Syscall.h"
#include "MonochromeLib.h"
#ifdef _DEBUG
#include "Gray.c"
#include "GetKeys.c"
#include "MonochromeLib.c"
#include "Syscallasm.src"
#endif

#ifndef _Bool
#define _Bool
typedef enum { FALSE, TRUE } Bool;
#endif
typedef enum { RIGHT, DOWN, LEFT, UP } Direction;

// #pragma inline (abs)
// #pragma inline (min)
// #pragma inline (max)
// #pragma inline (clamp)
// #pragma inline (mod)
// #pragma inline (rotateUp)
// #pragma inline (rotateDown)

static int abs(x)
{
	if (x < 0)
		x = -x;
	return x;
}
static int min(x, y)
{
	if (x > y)
		x = y;
	return x;
}
static int max(x, y)
{
	if (x > y)
		y = x;
	return y;
}
static int clamp(x, min, max)
{
	if (x < min)
		x = min;
	if (x > max)
		x = max;
	return x;
}
static int mod(x, y)
{
	x %= y;
	if (x < 0)
		x += y;
	return x;
}
static int rotateUp(x, min, max)
{
	x++;
	if (x > max)
		x = min;
	return x;
}
static int rotateDown(x, min, max)
{
	x--;
	if (x < min)
		x = max;
	return x;
}